<template>
  <div class="container">
    <h2>New Path</h2>
    <b-form-input
      v-model="departure_id"
      required
      placeholder="departure id"
      type="number">
    </b-form-input>
    <small>In case you don't know the departure id, visit <nuxt-link to="/admin/locations">locations</nuxt-link></small>
    <b-form-input
      v-model="destination_id"
      required
      placeholder="destination id"
      type="number">
    </b-form-input>
    <small>In case you don't know the destination id, visit <nuxt-link to="/admin/locations">locations</nuxt-link></small>
    <b-form-input
      v-model="plength"
      placeholder="length"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      departure_id: '',
      destination_id: '',
      plength: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.departure_id * this.destination_id * (this.plength+1);
    }
  },
  methods: {
    submit() {
      let data = {
        path: {
          destination_id: this.destination_id,
          departure_id: this.departure_id,
          length: this.plength
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/paths',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
